// File autogenerated

#if !defined(FILECHOOSERINTERFACE_H_INCLUDED)
#define FILECHOOSERINTERFACE_H_INCLUDED

// TQt includes
#include <tqmap.h>

// TQt D-Bus includes
#include <tqdbuserror.h>
#include <tqdbusmessage.h>
#include <tqdbusobject.h>

// forward declarations
class TQDomElement;
class TQString;
class TQT_DBusError;
class TQT_DBusObjectPath;
class TQT_DBusVariant;

namespace org
{
namespace freedesktop
{
namespace impl
{
namespace portal
{

class FileChooserInterface : public TQT_DBusObjectBase
{
public:
    virtual ~FileChooserInterface() {}

    static void buildIntrospectionData(TQDomElement& interfaceElement);

public:
    virtual void OpenFileAsyncReply(int asyncCallId, TQ_UINT32 response, const TQMap< TQString, TQT_DBusVariant >& results);

    virtual void OpenFileAsyncError(int asyncCallId, const TQT_DBusError& error);

    virtual void SaveFileAsyncReply(int asyncCallId, TQ_UINT32 response, const TQMap< TQString, TQT_DBusVariant >& results);

    virtual void SaveFileAsyncError(int asyncCallId, const TQT_DBusError& error);

    virtual void SaveFilesAsyncReply(int asyncCallId, TQ_UINT32 response, const TQMap< TQString, TQT_DBusVariant >& results);

    virtual void SaveFilesAsyncError(int asyncCallId, const TQT_DBusError& error);

protected:
    virtual void OpenFileAsync(int asyncCallId, const TQT_DBusObjectPath& handle, const TQString& app_id, const TQString& parent_window, const TQString& title, const TQMap< TQString, TQT_DBusVariant >& options) = 0;

    virtual void SaveFileAsync(int asyncCallId, const TQT_DBusObjectPath& handle, const TQString& app_id, const TQString& parent_window, const TQString& title, const TQMap< TQString, TQT_DBusVariant >& options) = 0;

    virtual void SaveFilesAsync(int asyncCallId, const TQT_DBusObjectPath& handle, const TQString& app_id, const TQString& parent_window, const TQString& title, const TQMap< TQString, TQT_DBusVariant >& options) = 0;

protected: // implement sending replies
    virtual void handleMethodReply(const TQT_DBusMessage& reply) = 0;

protected: // usually no need to reimplement
    virtual bool handleMethodCall(const TQT_DBusMessage& message);

    void callOpenFileAsync(const TQT_DBusMessage& message);

    void callSaveFileAsync(const TQT_DBusMessage& message);

    void callSaveFilesAsync(const TQT_DBusMessage& message);

protected:
    TQMap<int, TQT_DBusMessage> m_asyncCalls;

}; // class FileChooserInterface

}; // namespace portal

}; // namespace impl

}; // namespace freedesktop

}; // namespace org

#endif //FILECHOOSERINTERFACE_H_INCLUDED

// End of File

